--[[

    MinipetLeash

    Written by Cragganmore, modified by Anette

    MinipetLeash automatically reminds you to summon an ornamental pet (such as a cat or rabbit).
    No more forgetting to resummon your pal when you hearthstone, dismount a taxi, or resurrect.
    
    You can specify the pet to summon, or let the program choose a random one from your inventory
    each time.
    
  ]]--

-- Global Constants
MINIPETLEASH_VERSION = "1.00";
MINIPETLEASH_DEBUG = false;

MINIPETLEASH_CONFIG = { };
MINIPETLEASH_PETITEMNAMES = {"Zergling Leash", "Panda Collar", "Cat Carrier (Bombay)", 
                                    "Cat Carrier (Cornish Rex)", "Cat Carrier (Maine Coon)", 
                                    "Cat Carrier (Orange Tabby)", "Cat Carrier (Siamese)", 
                                    "Cat Carrier (Silver Tabby)", "Cat Carrier (White Kitten)", 
                                    "Rabbit Crate (Snowshoe)", "Mechanical Squirrel Box", "Diablo Stone", 
                                    "Parrot Cage (Cockatiel)", "Parrot Cage (Green Wing Macaw)", 
                                    "Parrot Cage (Hyacinth Macaw)", "Parrot Cage (Senegal)",
                                    "Ancona Chicken", "Sprite Darter Egg", "Great Horned Owl", 
                                    "Hawk Owl", "Prairie Dog Whistle", "Cockroach", "Black Kingsnake", 
                                    "Brown Snake", "Crimson Snake", "Tiny Black Whelpling", 
                                    "Tiny Crimson Whelpling", "Tiny Emerald Whelpling", 
                                    "Lifelike Mechanical Toad", "Mechanical Chicken", "Lil' Smoky",
                                    "Worg Carrier","Turtle Box", "Disgusting Oozeling", "Blue Murloc Egg", 
				    "Pet Bombling", "Captured Flame", "Tranquil Mechanical Yeti", 
				    "A Jubling's Tiny Home",  "Chicken Egg", "Wood Frog Box",  "Rat Cage", 
				    "Piglet's Collar", "Smolderweb Carrier"};

                                               
MinipetLeash_AlreadyAddedCharacterToConfig  = false;
MinipetLeash_ActivePetSet                   = false;
MinipetLeash_BoardedTaxi                    = false;
MinipetLeash_StartedHearthstone             = false;
MinipetLeash_HearthstoneComplete            = false;
MinipetLeash_PlayerDied                     = false;
MinipetLeash_PlayerReborn                   = false;
MinipetLeash_PlayerEnteringWorld            = true;
MinipetLeash_ReadyToInitialize              = false;
MinipetLeash_InitialPlayerAliveCount        = 0;


StaticPopupDialogs["PET_SUMMON"] = {
  text = "Do you want to summon a pet?",
  button1 = "Yes",
  button2 = "No",
  OnAccept = function() 
	MinipetLeash_ActivatePet();
  end,
  timeout = 0,
  hideOnEscape = 1
};

-- Bindings Names

BINDING_HEADER_MINIPETLEASH = "Minipet Leash";
BINDING_NAME_MINIPETLEASH_POPPET = "Pop Pet";

-- Local Variables (Movement)

local posx, posx1, posy, posy1, posz, posz1;

-----------------------------------------------------------------------------------
--
-- Checks for events 
--
-----------------------------------------------------------------------------------
function MinipetLeash_OnEvent(event)
   

    if (MINIPETLEASH_DEBUG) then
        if (event == "INSTANCE_BOOT_STOP") then
            if (MINIPETLEASH_DEBUG) then Print("MinipetLeash: Event seen INSTANCE_BOOT_STOP") end;
        elseif (event == "TAXIMAP_OPENED") then
            if (MINIPETLEASH_DEBUG) then Print("MinipetLeash: Event seen TAXIMAP_OPENED") end;
        elseif (event == "TAXIMAP_CLOSED") then
            if (MINIPETLEASH_DEBUG) then Print("MinipetLeash: Event seen TAXIMAP_CLOSED") end;
        elseif (event == "PLAYER_CONTROL_LOST") then
            if (MINIPETLEASH_DEBUG) then Print("MinipetLeash: Event seen PLAYER_CONTROL_LOST") end;
        elseif (event == "PLAYER_CONTROL_GAINED") then
            if (MINIPETLEASH_DEBUG) then Print("MinipetLeash: Event seen PLAYER_CONTROL_GAINED") end;
        elseif (event == "CONFIRM_SUMMON") then
            if (MINIPETLEASH_DEBUG) then Print("MinipetLeash: Event seen CONFIRM_SUMMON") end;
        elseif (event == "PLAYER_DEAD") then
            if (MINIPETLEASH_DEBUG) then Print("MinipetLeash: Event seen PLAYER_DEAD") end;
        elseif (event == "PLAYER_ALIVE") then
            if (MINIPETLEASH_DEBUG) then Print("MinipetLeash: Event seen PLAYER_ALIVE") end;
        elseif (event == "SPELLCAST_START") then
            if (arg1 == "Hearthstone") then
                if (MINIPETLEASH_DEBUG) then Print("MinipetLeash: Event seen SPELLCAST_START Hearthstone") end;
            end
        elseif (event == "SPELLCAST_FAILED") then
            if (MINIPETLEASH_DEBUG) then Print("MinipetLeash: Event seen SPELLCAST_FAILED") end;
        elseif (event == "SPELLCAST_INTERRUPTED") then
            if (MINIPETLEASH_DEBUG) then Print("MinipetLeash: Event seen SPELLCAST_INTERRUPTED") end;
        elseif (event == "SPELLCAST_STOP") then
            if (MINIPETLEASH_DEBUG) then Print("MinipetLeash: Event seen SPELLCAST_STOP") end;  
        end
    end 
    
    --if (event == "PLAYER_ALIVE" and MinipetLeash_PlayerEnteringWorld) then
      --  MinipetLeash_InitialPlayerAliveCount = MinipetLeash_InitialPlayerAliveCount + 1
        --if (MinipetLeash_InitialPlayerAliveCount == 2) then
          --  MinipetLeash_ReadyToInitialize = true;
        --end
    if (event == "TAXIMAP_CLOSED") then
        MinipetLeash_BoardedTaxi = true;
    elseif (event == "PLAYER_CONTROL_GAINED" and MinipetLeash_BoardedTaxi) then
        MinipetLeash_BoardedTaxi = false;
        MinipetLeash_popupActivatePet();
    elseif (event == "SPELLCAST_START") then
        if (arg1 == "Hearthstone") then
            if (MINIPETLEASH_DEBUG) then Print("MinipetLeash: MinipetLeash_StartedHearthstone") end;
            MinipetLeash_StartedHearthstone = true; 
        else
            MinipetLeash_StartedHearthstone = false;
        end
    elseif (event == "SPELLCAST_STOP") then
        if (MinipetLeash_StartedHearthstone) then
            if (MINIPETLEASH_DEBUG) then Print("MinipetLeash: Finished Hearthstone!") end;
            MinipetLeash_StartedHearthstone = false;
            MinipetLeash_HearthstoneComplete = true;
	    MinipetLeash_popupActivatePet();
        end
    elseif (event == "PLAYER_ALIVE" and MinipetLeash_HearthstoneComplete) then
        MinipetLeash_HearthstoneComplete = false;
        MinipetLeash_PlayerReborn = false;
        if (MINIPETLEASH_DEBUG) then Print("MinipetLeash: Activating Pet After Hearthstone!") end;
        MinipetLeash_popupActivatePet();    
    elseif (event == "PLAYER_DEAD") then
        if (MINIPETLEASH_DEBUG) then Print("MinipetLeash: MinipetLeash_PlayerDied") end;
        MinipetLeash_PlayerDied = true;
    elseif (event == "PLAYER_ENTERING_WORLD") then
        MinipetLeash_PlayerEnteringWorld = false;
        --if (MINIPETLEASH_DEBUG) then Print("MinipetLeash: Activating Pet After Hearthstone!") end;
        MinipetLeash_popupActivatePet();
    end
    -- enterworld       event = PLAYER_ENTERING_WORLD 
    -- enterinstance    event = PLAYER_ENTERING_WORLD
    -- get off taxi     TAXIMAP_OPENED, TAXIMAP_CLOSED, PLAYER_CONTROL_LOST, PLAYER_ALIVE, PLAYER_CONTROL_GAINED, PLAYER_ALIVE
    -- teleported       event = PLAYER_CONTROL_LOST/PLAYER_CONTROL_GAINED  ??
    -- summoned         event = CONFIRM_SUMMON
    -- hearthstoned     SPELLCAST_START (hearthstone), SPELLCAST_STOP, PLAYER_ALIVE
    -- dies             PLAYER_DEAD, lots of PLAYER_ALIVE (as soon as become a ghost), use UnitIsDeadOrGhost("unit") 
    -- rez              event = PLAYER_DEAD, event = PLAYER_ALIVE, UnitIsDeadOrGhost("unit")
    
end



---------------------------------------------------------------------------------
--
-- Register with Cosmos UI
-- 
---------------------------------------------------------------------------------
function MinipetLeash_RegisterCosmos()

    if (MINIPETLEASH_DEBUG) then Print("MinipetLeash_RegisterCosmos") end;    
    --
    -- Add an entry to the Cosmos configuration menu
    --
    if (Cosmos_RegisterConfiguration) then
        Cosmos_RegisterConfiguration(
            "COS_MINIPETLEASH",
            "SECTION",
            MINIPETLEASH_CONFIG_HEADER,
            MINIPETLEASH_CONFIG_HEADER_INFO
        );
        Cosmos_RegisterConfiguration(
            "COS_MINIPETLEASH_HEADER",
            "SEPARATOR",
            MINIPETLEASH_CONFIG_HEADER,
            MINIPETLEASH_CONFIG_HEADER_INFO
        );
        Cosmos_RegisterConfiguration(
            "COS_MINIPETLEASH_ENABLED",
            "CHECKBOX",
            MINIPETLEASH_CONFIG_ENABLED,
            MINIPETLEASH_CONFIG_ENABLED_INFO,
            MinipetLeash_Toggle,
            true
        );
        
        -- register our chat commands
        local MinipetLeashCommands = {"/leash", "/mpl"};
        Cosmos_RegisterChatCommand (
            "MINIPETLEASH_COMMANDS", -- Some Unique Group ID
            MinipetLeashCommands, -- The Commands
            MinipetLeash_ChatCommandHandler,
            "" -- Description String
        );
    else
        SlashCmdList["MINIPETLEASHSLASH"] = MinipetLeash_ChatCommandHandler;
        SLASH_MINIPETLEASHSLASH1 = "/leash";
        SLASH_MINIPETLEASHSLASH2 = "/mpl";
        SlashCmdList["POPPETSLASH"] = PopPet_ChatCommandHandler;
        SLASH_POPPETSLASH1 = "/poppet";
        SLASH_POPPETSLASH2 = "/pp";
    end
    
    -- make sure we have the Print() function
    if (not Print) then
        function Print(msg, r, g, b, frame) 
            if (not r) then r = 1.0; end
            if (not g) then g = 1.0; end
            if (not b) then b = 1.0; end
            if ( frame ) then 
                frame:AddMessage(msg,r,g,b);
            else
                if ( DEFAULT_CHAT_FRAME ) then 
                    DEFAULT_CHAT_FRAME:AddMessage(msg, r, g, b);
                end
            end
        end
    end
end


---------------------------------------------------------------------------------
--
-- MinipetLeash_ParseCommand
-- 
---------------------------------------------------------------------------------
function MinipetLeash_ParseCommand(msg)
    firstSpace = string.find(msg, " ", 1, true);
    if (firstSpace) then
        local command = string.sub(msg, 1, firstSpace - 1);
        local var  = string.sub(msg, firstSpace + 1);
        return command, var
    else
        return msg, nil;
    end
end


---------------------------------------------------------------------------------
--
-- A simple chat command handler, right now just used for debugging purposes
-- 
---------------------------------------------------------------------------------
function MinipetLeash_ChatCommandHandler(msg)

    MinipetLeash_CheckForOurConfigNumber();

    if (ThisCharacterConfig) then
        if (MINIPETLEASH_CONFIG[ThisCharacterConfig].ENABLED) then
            local command, var = MinipetLeash_ParseCommand(msg);
            if ((not command) and msg) then
                command = msg;
            end
            if (command) then
                command = string.lower(command);
                if (command == "debug") then
                    MinipetLeash_ToggleDebug();
                elseif (command == "test") then
                    MinipetLeash_ActivatePet();
                elseif (command == "set") then
                    MinipetLeash_SetActivePet(var);
                elseif (command == "reset") then
                    MinipetLeash_ResetActivePet();
                elseif (command == "reloadui") then
                    MinipetLeash_PlayerEnteringWorld = false;
                elseif (command == "add") then
                    MinipetLeash_AddPetToDatabase(var);
                elseif (command == "delete") then
                    MinipetLeash_DeletePetFromDatabase(var);
                elseif (command == "list") then
                    MinipetLeash_ListPetDatabase();
                elseif (command == "movewarn") then
                    if (MINIPETLEASH_CONFIG[ThisCharacterConfig].MoveWarn == nil)
                    or (MINIPETLEASH_CONFIG[ThisCharacterConfig].MoveWarn == 0) then
                        MINIPETLEASH_CONFIG[ThisCharacterConfig].MoveWarn = 1;
                        ChatFrame1:AddMessage("MinipetLeash_MoveWarn: Activated.", 1.0, 1.0, 0.5);
                    else
                        MINIPETLEASH_CONFIG[ThisCharacterConfig].MoveWarn = 0;
                        ChatFrame1:AddMessage("MinipetLeash_MoveWarn: Deactivated.", 1.0, 1.0, 0.5);
                    end
		elseif (command == "bg") then
                    if (MINIPETLEASH_CONFIG[ThisCharacterConfig].Bg == nil)
                    or (MINIPETLEASH_CONFIG[ThisCharacterConfig].Bg == 0) then
                        MINIPETLEASH_CONFIG[ThisCharacterConfig].Bg = 1;
                        ChatFrame1:AddMessage("MinipetLeash toggle: Popup inactivated in Battlegrounds.", 1.0, 1.0, 0.5);
                    else
                        MINIPETLEASH_CONFIG[ThisCharacterConfig].Bg = 0;
                        ChatFrame1:AddMessage("MinipetLeash toggle: Popup activated in Battlegrounds.", 1.0, 1.0, 0.5);
                    end                       
                elseif (command == "version") then
                    Print("MinipetLeash version "..MINIPETLEASH_VERSION, 1.0, 1.0, 0.5);
                else
                    Print("MinipetLeash, an AddOn by Cragganmore", 1.0, 1.0, 0.5);
                    Print("MinipetLeash will remind you to summon an ornamental pet", 1.0, 1.0, 0.5);
                    Print("(i.e. cat, prairie dog, etc) from your inventory whenever", 1.0, 1.0, 0.5);
                    Print("you hearthstone, dismount a taxi, or resurrect.  You", 1.0, 1.0, 0.5);
                    Print("can specify the pet to summon, or let the program select", 1.0, 1.0, 0.5);
                    Print("a random one from your inventory each time.", 1.0, 1.0, 0.5);
                    Print("Usage: /leash <set/reset/add/delete/list/bg>", 1.0, 1.0, 0.5);
                    Print("   set [exact pet name] - Set the pet as your default pet.", 1.0, 1.0, 0.5);
                    Print("     Example: /leash set Mechanical Squirrel Box.", 1.0, 1.0, 0.5);
                    Print("   reset - Unset a default pet and return the pet choice", 1.0, 1.0, 0.5);
                    Print("     to random mode.", 1.0, 1.0, 0.5);
                    Print("   add [exact pet name] - Add the specified pet to", 1.0, 1.0, 0.5);
                    Print("     the database of randomly selectable pets.", 1.0, 1.0, 0.5);
                    Print("   delete [exact pet name] - Delete the specified pet from", 1.0, 1.0, 0.5);
                    Print("     the database of randomly selectable pets.", 1.0, 1.0, 0.5);
                    Print("   list - Show the database of randomly selectable pets.", 1.0, 1.0, 0.5);
		    Print("   bg - Toggles the addon to not give you popup windows", 1.0, 1.0, 0.5);
		    Print("   while in a Battleground", 1.0, 1.0, 0.5);
                end
            end
        end
    end

end

function PopPet_ChatCommandHandler()
    -- MINIPETLEASH_BYPASS = 1;
    ChatFrame1:AddMessage("MinipetLeash_PopPet: Popping pet ...", 1.0, 1.0, 0.5);
    MinipetLeash_GetThisCharactersConfigNumber();
    MinipetLeash_ActivatePet();
end

-----------------------------------------------------------------------------------
--
-- Handle the loading stuff when the plugin first loads
--
-----------------------------------------------------------------------------------
function MinipetLeash_OnLoad()  
    
    if (MINIPETLEASH_DEBUG) then Print("MinipetLeash_OnLoad") end;    

    this:RegisterEvent("PLAYER_ENTERING_WORLD");   
    this:RegisterEvent("INSTANCE_BOOT_STOP");
    this:RegisterEvent("TAXIMAP_OPENED");
    this:RegisterEvent("TAXIMAP_CLOSED");
    this:RegisterEvent("PLAYER_CONTROL_LOST");
    this:RegisterEvent("PLAYER_CONTROL_GAINED");
    this:RegisterEvent("CONFIRM_SUMMON");
    this:RegisterEvent("PLAYER_DEAD");
    this:RegisterEvent("PLAYER_ALIVE");
    this:RegisterEvent("SPELLCAST_START");
    this:RegisterEvent("SPELLCAST_FAILED");
    this:RegisterEvent("SPELLCAST_INTERRUPTED");
    this:RegisterEvent("SPELLCAST_STOP");

	
    
    -- register with Cosmos
    MinipetLeash_RegisterCosmos();
end



-----------------------------------------------------------------------------------
--
-- Workaround functions to handle a problem where the money field of a tooltip
-- will get hidden whenever tooltips are invoked.
-- 
-- Code by Telo.  From his post:
--   "Whenever a tooltip is set, the game sends a CLEAR_TOOLTIP event, which causes GameTooltip_OnEvent to call 
--   GameTooltip_ClearMoney, hiding the money frame for GameTooltip. There doesn't appear to be any identifying 
--   information sent with the CLEAR_TOOLTIP event that would allow GameTooltip_OnEvent to discriminate between 
--   its tooltip and others, so simply hooking this function doesn't appear to help. I've worked around the 
--   issue for my code by using something similar to the following code wherever I use a hidden tooltip."
--   (http://forums.worldofwarcraft.com/thread.aspx?fn=wow-interface-customization&t=16768&tmp=1#post16768)
--
-----------------------------------------------------------------------------------
local lOriginal_GameTooltip_ClearMoney;
local function MinipetLeash_MoneyToggle()
    if( lOriginal_GameTooltip_ClearMoney ) then
        GameTooltip_ClearMoney = lOriginal_GameTooltip_ClearMoney;
        lOriginal_GameTooltip_ClearMoney = nil;
    else
        lOriginal_GameTooltip_ClearMoney = GameTooltip_ClearMoney;
        GameTooltip_ClearMoney = MinipetLeash_GameTooltip_ClearMoney;
    end
end
function MinipetLeash_GameTooltip_ClearMoney()
    -- Intentionally empty; don't clear money while we use hidden tooltips
end



-----------------------------------------------------------------------------------
--
-- MinipetLeash_InsertPetIntoInventoryList
--
-----------------------------------------------------------------------------------
function MinipetLeash_InsertPetIntoInventoryList(bag, slot, petItemName)
    local tmpTable = { };
    tmpTable.bag = bag;
    tmpTable.slot = slot;
    tmpTable.name = petItemName;
    table.insert(MinipetLeash_PetItemsInInventory, tmpTable);
end


-----------------------------------------------------------------------------------
--
-- MinipetLeash_InventoryAllPetItems
--
-----------------------------------------------------------------------------------
function MinipetLeash_InventoryAllPetItems(petNameToFind)   

    MinipetLeash_PetItemsInInventory = { };
    
    -- for each bag
    local bag = 0;
    for bag = 4, 0, -1 do
        local size = GetContainerNumSlots(bag);
        if (size > 0) then
        
            -- for each slot in the bag
            local slot = 0;
            for slot = 1, size, 1 do
            
                -- get info about the item in this slot
                local texture, itemCount = GetContainerItemInfo(bag, slot);
                if (itemCount) then
                    local itemName = nil;
                    
                    -- point our tooltip at this item so we can read its name, etc
                    MinipetLeash_MoneyToggle();
                    getglobal("MinipetLeashTooltip"):SetBagItem(bag, slot);
                    local ttext = getglobal("MinipetLeashTooltipTextLeft1");
                    MinipetLeash_MoneyToggle();
                    
                    -- if the tooltip had info, store it
                    if (ttext and ttext:IsVisible() and ttext:GetText() ~= nil) then
                        
                        -- if the item has a name
                        itemName = ttext:GetText();
                        if (itemName ~= nil) then

                            -- if this item is on the list of items that can summon a pet                       
                            for i = 1, table.getn(MINIPETLEASH_PETITEMNAMES) do                         
                                petItemName = MINIPETLEASH_PETITEMNAMES[i];
                                if (itemName == petItemName) then
                                    
                                    -- if we called this function to see if a petname was in inventory
                                    -- then check for the pet name
                                    if (petNameToFind) then
                                        if (itemName == petNameToFind) then
                                            MinipetLeash_InsertPetIntoInventoryList(bag, slot, petItemName);
                                            return true;
                                        end
                                    else
                                        MinipetLeash_InsertPetIntoInventoryList(bag, slot, petItemName);
                                    end
                                end
                            end
                        end
                    end
                end
            end
        end
    end
    
    -- if we called this function to see if a petname was in inventory
    -- then at this point we didn't find one, so return false
    if (petNameToFind) then
        return false;
    end
    
    if (MINIPETLEASH_DEBUG) then
        tmpString = "";
        for i = 1, table.getn(MinipetLeash_PetItemsInInventory) do
            tmpString = tmpString..MinipetLeash_PetItemsInInventory[i].name.." ";
        end
        Print("MinipetLeash: Found pets in inventory - "..tmpString);
    end
end


-----------------------------------------------------------------------------------
--
-- Add a pet to the database of possible pets to choose from
--
-----------------------------------------------------------------------------------
function MinipetLeash_AddPetToDatabase(petName)

    MinipetLeash_CheckForOurConfigNumber();

    if (petName ~= "") then
        petName = MinipetLeash_GetItemNameFromHyperLink(petName);
        table.insert(MINIPETLEASH_PETITEMNAMES, petName);
        Print("MinipetLeash: Added "..petName.." to list of useable pets.", 1.0, 1.0, 0.5);
        MinipetLeash_ListPetDatabase()
    else
        Print("MinipetLeash: Please enter the name of a pet to add to the list of useable pets.", 1.0, 1.0, 0.5);
    end
end


-----------------------------------------------------------------------------------
--
-- Delete a pet from the database of possible pets to choose from
--
-----------------------------------------------------------------------------------
function MinipetLeash_DeletePetFromDatabase(petName)

    MinipetLeash_CheckForOurConfigNumber();

    if (petName ~= "") then
        petName = MinipetLeash_GetItemNameFromHyperLink(petName);
        
        local indexNum = 0;
        for i = 1, table.getn(MINIPETLEASH_PETITEMNAMES) do
            if (MINIPETLEASH_PETITEMNAMES[i] == petName) then
                indexNum = i;
                break;
            end
        end
        
        if (indexNum == 0) then
            Print("MinipetLeash: Unable to find \""..petName.."\" in the list of useable pets.", 1.0, 1.0, 0.5);
        else
            table.remove(MINIPETLEASH_PETITEMNAMES, indexNum);
            Print("MinipetLeash: Removed "..petName.." from list of useable pets.", 1.0, 1.0, 0.5);
        end
        MinipetLeash_ListPetDatabase()    
    else
        Print("MinipetLeash: Please enter the name of a pet to add to the list of useable pets.", 1.0, 1.0, 0.5);
    end
end


-----------------------------------------------------------------------------------
--
-- List all the pets in the database of possible pets to choose from
--
-----------------------------------------------------------------------------------
function MinipetLeash_ListPetDatabase()
    Print("Pets in the database are:", 1.0, 1.0, 0.5);
    for i = 1, table.getn(MINIPETLEASH_PETITEMNAMES) do
        Print("  o \""..MINIPETLEASH_PETITEMNAMES[i].."\"", 1.0, 1.0, 0.5)
    end
end



-----------------------------------------------------------------------------------
--
-- MinipetLeash_SetActivePet
--
-----------------------------------------------------------------------------------
function MinipetLeash_SetActivePet(petName)

    MinipetLeash_CheckForOurConfigNumber();

    if (ThisCharacterConfig) then
        if (MINIPETLEASH_CONFIG[ThisCharacterConfig].ENABLED) then
            if (petName) then

                -- remove any [ ] in case the player hyperlinked an item instead of typing it
                petName = MinipetLeash_GetItemNameFromHyperLink(petName);

                if (MINIPETLEASH_DEBUG) then Print("Trying to set ["..petName.."] as default pet...") end;
                local petInInventory = MinipetLeash_InventoryAllPetItems(petName);
                if (petInInventory) then
                    ChatFrame1:AddMessage("MinipetLeash: \""..petName.."\" set as default pet.", 1.0, 1.0, 0.5);
                    MINIPETLEASH_CONFIG[ThisCharacterConfig].PREFERRED_PET = petName;
                    MinipetLeash_ActivePetSet = true;
                else
                    ChatFrame1:AddMessage("MinipetLeash: Error! \""..petName.."\" not found in inventory!", 1.0, 1.0, 0.5);
                    MinipetLeash_InventoryAllPetItems();
                    MinipetLeash_ActivePetSet = false;
                end
            else
                ChatFrame1:AddMessage("MinipetLeash: Specify name of pet to set!", 1.0, 1.0, 0.5);
                MinipetLeash_ActivePetSet = false;
            end
        end
    end
end


-----------------------------------------------------------------------------------
--
-- MinipetLeash_SetActivePet
--
-----------------------------------------------------------------------------------
function MinipetLeash_ResetActivePet()

    MinipetLeash_CheckForOurConfigNumber();
    
    MinipetLeash_ActivePetSet = false;
    MINIPETLEASH_CONFIG[ThisCharacterConfig].PREFERRED_PET = "";
    MinipetLeash_InventoryAllPetItems();
    ChatFrame1:AddMessage("MinipetLeash: Default pet reset to random.  Possible pets are:", 1.0, 1.0, 0.5);
    for i = 1, table.getn(MinipetLeash_PetItemsInInventory) do
        ChatFrame1:AddMessage("  o \""..MinipetLeash_PetItemsInInventory[i].name.."\"");
    end
end


-----------------------------------------------------------------------------------
--
-- MinipetLeash_ActivatePet
--
-----------------------------------------------------------------------------------

function MinipetLeash_ActivatePet()

    if (ThisCharacterConfig == nil) then
        ChatFrame1:AddMessage("MinipetLeash: The client has not finished setting up yet.  Try again in a few seconds.", 1.0, 1.0, 0.5);
        return;
    end

    if (MINIPETLEASH_CONFIG[ThisCharacterConfig].MoveWarn == nil) then
        MINIPETLEASH_CONFIG[ThisCharacterConfig].MoveWarn = 1;
    end

    if (MINIPETLEASH_BYPASS == 0) and (MINIPETLEASH_CONFIG[ThisCharacterConfig].MoveWarn == 1) and not (posx == posx1 and posy == posy1 and posz == posz1) then
        MinipetLeashTextFrameText:SetTextColor(1.0, 0.1, 0.1);
        MinipetLeashTextFrameText:SetText("You moved too soon!  Activate your pet manually with the /poppet command or the keybinding.");
        MinipetLeashTextFrame.startTime = GetTime();
        PlaySound("AuctionWindowOpen");
        MinipetLeashTextFrame:Show();
        return;
    end

    MinipetLeash_CheckForOurConfigNumber();
    
    if (ThisCharacterConfig) then
        if (MINIPETLEASH_CONFIG[ThisCharacterConfig].ENABLED) then
        
            
	    
	    -- find all the pets in our inventory
            if (not MinipetLeash_ActivePetSet) then
                MinipetLeash_InventoryAllPetItems();
            end

            -- select a random pet
            if (table.getn(MinipetLeash_PetItemsInInventory) > 0) then
                --Print("table.getn(MinipetLeash_PetItemsInInventory) = ["..table.getn(MinipetLeash_PetItemsInInventory).."]");
                local selectedPet = MinipetLeash_PetItemsInInventory[math.random(table.getn(MinipetLeash_PetItemsInInventory))];
                if (MINIPETLEASH_DEBUG) then Print("MinipetLeash: Selected pet "..selectedPet.name) end;

                -- activate the pet
                if (selectedPet) then
			UseContainerItem(selectedPet.bag, selectedPet.slot);
                    Print("MinipetLeash is using "..selectedPet.name, 1.0, 1.0, 0.5); 
                    if (MINIPETLEASH_DEBUG) then Print("MinipetLeash: Activating "..selectedPet.name) end;
                else
                    if (MINIPETLEASH_DEBUG) then Print("MinipetLeash: No pets found in inventory!") end;
                end
            else
                ChatFrame1:AddMessage("MinipetLeash_ActivatePet: No pets found in inventory!", 1.0, 1.0, 0.5);
            end
		end -- end config check
    end
end


-----------------------------------------------------------------------------------
--
-- Update
--
-----------------------------------------------------------------------------------
function MinipetLeash_OnUpdate()
    --if (MINIPETLEASH_CONFIG[ThisCharacterConfig].ENABLED) then
    if (UnitName("player") ~= "Unknown Being" and UnitName("player") ~= "Unknown Entity" and MinipetLeash_ReadyToInitialize) then
        if (MINIPETLEASH_DEBUG) then Print("MinipetLeash: MinipetLeash_PlayerEnteringWorld and ALIVE") end;
        MinipetLeash_PlayerEnteringWorld = false;
        MinipetLeash_ReadyToInitialize = false;
        MinipetLeash_CheckForOurConfigNumber();
        if (MINIPETLEASH_CONFIG[ThisCharacterConfig].PREFERRED_PET ~= "") then
            if (MINIPETLEASH_DEBUG) then Print("MinipetLeash: Found preferred pet = "..MINIPETLEASH_CONFIG[ThisCharacterConfig].PREFERRED_PET) end;
            MinipetLeash_SetActivePet(MINIPETLEASH_CONFIG[ThisCharacterConfig].PREFERRED_PET);
        end
        MinipetLeash_popupActivatePet();     
    end
    if (MinipetLeash_PlayerDied) then
        if (not UnitIsDeadOrGhost("player")) then
            if (MINIPETLEASH_DEBUG) then Print("MinipetLeash: no longer deadorghost!") end;
            MinipetLeash_PlayerDied = false;
            MinipetLeash_popupActivatePet();
        end
    end
    --end
    posx1 = posx;
    posy1 = posy;
    posz1 = posz;
    posx, posy, posz = GetPlayerMapPosition("player");
end


-----------------------------------------------------------------------------------
--
-- Toggle Debug
--
-----------------------------------------------------------------------------------
function MinipetLeash_ToggleDebug()
    MINIPETLEASH_DEBUG = (not MINIPETLEASH_DEBUG);
    if (MINIPETLEASH_DEBUG) then
        ChatFrame1:AddMessage("MinipetLeash: Debug On", 1.0, 1.0, 0.5);
    else
        ChatFrame1:AddMessage("MinipetLeash: Debug Off", 1.0, 1.0, 0.5);
    end
end



-----------------------------------------------------------------------------------
--
-- Toggle the AddOn on/off
--
-----------------------------------------------------------------------------------
function MinipetLeash_Toggle(toggle)

    MinipetLeash_CheckForOurConfigNumber();

    if (toggle == 1) then
        if (ThisCharacterConfig) then
            MINIPETLEASH_CONFIG[ThisCharacterConfig].ENABLED = true;
        end
    else
        if (ThisCharacterConfig) then
            MINIPETLEASH_CONFIG[ThisCharacterConfig].ENABLED = false;
        end
    end
end


-----------------------------------------------------------------------------------
--
-- Add the current character to the saved variables
-- so that each character can have his/her own configuration
--
-----------------------------------------------------------------------------------
function MinipetLeash_AddThisCharacterToConfigTable()
    tempTable = { };
    tempTable.PLAYERNAME = UnitName("player");
    tempTable.ENABLED = true;
    tempTable.PREFERRED_PET = "";
    tempTable.BATTLEGROUNDS_OFF = true;
    
    table.insert(MINIPETLEASH_CONFIG, tempTable);
end


-----------------------------------------------------------------------------------
--
-- Find this character's entry in the configuration table
--
-----------------------------------------------------------------------------------
function MinipetLeash_GetThisCharactersConfigNumber()
    ThisCharacterConfig = nil;
    for i = 1, table.getn(MINIPETLEASH_CONFIG) do
        if (MINIPETLEASH_CONFIG[i].PLAYERNAME == UnitName("player")) then
            ThisCharacterConfig = i;
            break;
        end
    end
    if (not ThisCharacterConfig) then
        MinipetLeash_AddThisCharacterToConfigTable();
        ThisCharacterConfig = table.getn(MINIPETLEASH_CONFIG);
    end
    MinipetLeash_AlreadyAddedCharacterToConfig = true;
end


-----------------------------------------------------------------------------------
--
-- See if we're in the configuration table
--
-----------------------------------------------------------------------------------
function MinipetLeash_CheckForOurConfigNumber()
    if (not MinipetLeash_AlreadyAddedCharacterToConfig) then
        MinipetLeash_GetThisCharactersConfigNumber();
    end
end


-----------------------------------------------------------------------------------
--
-- Given a hyperlink, return the item's name.  if not a hyperlink, returns the input text
--
-----------------------------------------------------------------------------------
function MinipetLeash_GetItemNameFromHyperLink(inputString)

    local outputString  = "";
    local firstBracket = 0;
    local secondBracket = 0;
    

    if (string.find(inputString, "%[")) then        
        MinipetLeashDebug("string.len(inputString) = "..string.len(inputString));
        
        for i = 1, string.len(inputString) do
            if (string.sub(inputString, i, i) == "[") then firstBracket = i end;
            if (string.sub(inputString, i, i) == "]") then secondBracket = i end;
        end
        
        MinipetLeashDebug("firstBracket = "..firstBracket.."  secondBracket = "..secondBracket);
        outputString = string.sub(inputString, firstBracket + 1, secondBracket - 1);
        MinipetLeashDebug("outputStringBracketed = "..outputString);
        
    else
        outputString = inputString;
    end
    
    return outputString;
end


-----------------------------------------------------------------------------------
--
-- Print a debug statement
--
-----------------------------------------------------------------------------------
function MinipetLeashDebug(theString)
    if (MINIPETLEASH_DEBUG) then
        Print("MinipetLeash: "..theString, 1, 1, 0.5);
    end
end

-----------------------------------------------------------------------------------
--
-- Popup
--
-----------------------------------------------------------------------------------

function MinipetLeash_popupActivatePet()
	MinipetLeash_GetThisCharactersConfigNumber();
	  
	if (MINIPETLEASH_CONFIG[ThisCharacterConfig].Bg == 1) then
	
	-- check if we are in a battleground
	    if ((GetZoneText() == "Warsong Gulch") or (GetZoneText() == "Arathi Basin") or (GetZoneText() == "Alterac Valley")) then
		return;		

		else
			StaticPopup_Show ("PET_SUMMON");
		end
		
	else
	    StaticPopup_Show ("PET_SUMMON");
	end
end

